Puppet::Type.newtype(:cfssl) do
    @doc = "Generate ssl certificates from cfssl"

    ensurable
    
    newparam(:server) do
        # http{s}?://localhost:8888
        desc "The cfssl Server"
    end

    newparam(:profile) do
        # string
        desc "The profile to use"
    end

    newparam(:bundle, boolean: true, parent: Puppet::Parameter::Boolean) do
        # boolean
        desc "Do we want cfssl to return a bundle"
        defaultto(:true)
    end

    newparam(:label) do
        # string
        desc "The label to use"
    end

    newparam(:subject) do
        # string
        desc "the certificate subject which overrides the ones in the CSR"
    end

    newparam(:hosts) do
        desc "an array of SAN (subject alternative names) which overrides the ones in the CSR"
    end

    newparam(:serial_sequence) do
        desc "an array of SAN (subject alternative names) which overrides the ones in the CSR"
    end

    newparam(:manifest) do
        # string
        desc "The cfssl certificate manifest"
    end

    newparam(:authkey) do
        # 32 character long hex string
        desc "The authkey to use against the selected profile"
    end

    newparam(:certname, :namevar => true) do
        # String
        desc "The file to write the generated certificate"
    end

    newparam(:certpath) do
        # Where to store the certificates.
        desc "The file to write the generated rsa key"
        defaultto("/tmp/ssl")
    end
end
